luas = "sys/lua/menufuncs/menufuncs.lua"


-------------------------------------------
luaload_use = true

if not luaload_use then return end
function string:toTable(m)
	m = m or "%s"
	local tbl = {}
	for w in self:gmatch("[^" .. m .. "]+") do
		table.insert(tbl, w)
	end
	return tbl
end

function string:fileup()
	local s = ""
	for i, v in ipairs(self:toTable("/")) do
		if i < #self:toTable("/") then
			s = s .. v .. "/"
		end
	end
	return s, self:sub(select(2, self:find(s)) + 1, -5)
end

function luaload_dofile(path)
	self = {}
	self.directory, self.name = path:fileup()
	dofile(path)
end

_print = print

function print(...)
	local args = {...}
	for i, v in pairs(args) do
		if type(v) == "table" then
			_print(tostring(v))
			for i, v in pairs(v) do
				print("[" .. i .. "] = " .. tostring(v))
			end
		else
			_print(tostring(v))
		end
	end
end

if luas then luaload_dofile(luas) end