local menu__ = {__menu = menu, menus = {}, hooks = {}, __addhook = addhook}

function string:split(m)
	local tbl = {}
	for w in self:gmatch("[^" .. (m or "%s") .. "]+") do
		table.insert(tbl, w)
	end
	return tbl
end

addhook = function(a, b, c)
	if a:lower() == "menu" then
		table.insert(menu__.hooks, b)
	else
		menu__.__addhook(a:lower(), b, c or 0)
	end
end

CreateMenu = function(str)
	local t = str:split(",")
	local ti = t[1]:split("@")[1]
	for i = 2, table.maxn(t), 1 do
		t[i - 1] = t[i]
	end
	t[table.maxn(t)] = nil
	menu__.menus[ti] = {t, data = {}}
	for i = 1, 32, 1 do
		menu__.menus[ti].data[i] = 1
	end
	return ti
end

CallMenu = function(id, men)
	if not menu__.menus[men] then return false end
	if id == 0 then
		for i = 1, 32, 1 do
			menu__.menus[men].data[i] = 1
			menu__.PageMenu(i, men)
		end
	else
		menu__.menus[men].data[id] = 1
		menu__.PageMenu(id, men)
	end
	return true
end

menu__.PageMenu = function(id, men)
	if not player(id, "exists") then return false end
	if not menu__.menus[men] then return false end
	local t = menu__.menus[men]
	local p = t.data[id]
	local str = men .. " " .. p
	for i = p * 7 - 6, p * 7, 1 do
		local c = t[1][i] or ""
		str = str .. "," .. c
	end
	menu__.__menu(id, str .. ",<<<|Back,Next|>>>")
	return true
end

DeleteMenu = function(str)
	for i, v in pairs(menu__.menus) do
		if i == str then
			menu__.menus[i] = nil
			return true
		end
	end
	return false
end

imenu = function(id, str) CallMenu(id, CreateMenu(str)) end

menu____menu_hook = function(id, men, sel)
	for menn in pairs(menu__.menus) do
		if type(menn) == "string" then
			if menn .. " " .. menu__.menus[menn].data[id] == men then
				if sel == 8 then
					menu__.menus[menn].data[id] = menu__.menus[menn].data[id] - 1
					if menu__.menus[menn].data[id] <= 0 then
						menu__.menus[menn].data[id] = 1
					end
					menu__.PageMenu(id, menn)
				elseif sel == 9 then
					menu__.menus[menn].data[id] = menu__.menus[menn].data[id] + 1
					menu__.PageMenu(id, menn)
				elseif type(sel) == "number" and sel > 0 then
					local sell = sel + menu__.menus[menn].data[id] * 7 - 7
					for i, v in ipairs(menu__.hooks) do
						loadstring(v .. "(" .. id .. ", \"" .. menn .. "\", " .. tostring(sell) .. ", \"" .. (menu__.menus[menn][1][sell] or "") .. "\")")()
					end
					return
				end
				return
			end
		end
	end
	for i, v in ipairs(menu__.hooks) do
		loadstring(v .. "(" .. id .. ", \"" .. menn .. "\", " .. tostring(sell) .. ")")()
	end
end
menu__.__addhook("menu", "menu____menu_hook")



serveraction_hook = function(id, a)
	local str = "Title,"
	for i = 1, 35, 1 do
		str = str .. "Button" .. i .. ","
	end
	imenu(id, str)
end
addhook("serveraction", "serveraction_hook")

menu_hook = function(id, men, sel, ssel)
	print("Player: " .. id .. "; Menu: " .. men .. "; Selection: " .. sel .. "; Button: " .. ssel)
end
addhook("menu", "menu_hook")